import * as react from 'react';
import { Dispatch, SetStateAction, MutableRefObject, Reducer, ReducerState } from 'react';

declare function useStateRef<T>(initialState: T | (() => T)): [T, Dispatch<SetStateAction<T>>, MutableRefObject<T>];
declare function useStateRef<T = undefined>(): [
    T | undefined,
    Dispatch<SetStateAction<T | undefined>>,
    MutableRefObject<T | undefined>
];

declare function export_default$1<R extends Reducer<any, any>>(reducer: R, initialValue: ReducerState<R>): readonly [ReducerState<R>, (action: Parameters<R>[1]) => void, react.MutableRefObject<ReducerState<R>>];

declare function export_default<T extends (...args: any[]) => any>(fn: T, delay: number | undefined, normalFn: Function): (...args: Parameters<T>) => void;

declare function useStateDebounce<T>(initialState: T | (() => T), delay?: number): [T, Dispatch<SetStateAction<T>>, T, Dispatch<SetStateAction<T>>];
declare function useStateDebounce<T = undefined>(initialState: undefined, delay?: number): [
    T | undefined,
    Dispatch<SetStateAction<T | undefined>>,
    T | undefined,
    Dispatch<SetStateAction<T | undefined>>
];

declare function useDebounceValue<T>(value: T | (() => T), delay?: number): T;
declare function useDebounceValue<T = undefined>(value: undefined, delay?: number): T | undefined;

export { export_default as useDebounce, useDebounceValue, export_default$1 as useReducerRef, useStateDebounce, useStateRef };
